<?php
/*------------------------------------------------------------------------
# plg_vtemtooltips - VTEM Tooltips Plugin
# ------------------------------------------------------------------------
# author Nguyen Van Tuyen
# copyright Copyright (C) 2010 VTEM.NET. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.vtem.net
# Technical Support: Forum - http://vtem.net/en/forum.html
-------------------------------------------------------------------------*/
// no direct access
defined("_JEXEC") or die("Restricted Access");
jimport('legacy.response.response');
jimport('joomla.environment.response');
jimport('joomla.document.document');
jimport('joomla.plugin.helper');
jimport('joomla.plugin.plugin');
jimport('joomla.html');
jimport('joomla.application.module.helper');

class plgSystemVtemTooltip extends JPlugin {
    //protected static $modules=array();
	function plgSystemVtemTooltip(&$subject, $config) {
		parent::__construct($subject, $config);
		$this->mainframe = JFactory::getApplication();
	}

	public function onAfterDispatch() {
		if($this->mainframe->isAdmin()) {
			return;
		}
		$document = JFactory::getDocument();
		$document->addStyleSheet( JURI::base(true) .'/media/plg_vtemtooltip/css/jquery.qtip.css');
	}
	
	public function onAfterRender() {
	  $body = JResponse::getBody();
	  if(!JString::strpos($body, 'vtemtooltip') || $this->mainframe->isAdmin()){
	    return;
	  }	
	  $regex = "#{vtemtooltip\s*(.*?)}#s";   
	  preg_match_all($regex, $body, $matches);
 	  if (!empty($matches[0])) {
 	    $this->_build($body, $matches);
 	    return true;
	  }
		return false;
	}

	private function _build( $body, $matches ){
		for( $i = 0; $i < count($matches[0]); $i++ ){
			$tipParams = $matches[1][$i];
			$tooltip    = "<script type='text/javascript' src='".JURI::base(true)."/media/plg_vtemtooltip/js/jquery.qtip.js'></script>";
			$sticky1 = "";
			$sticky2 = "";
			$style    = $this->_params( $tipParams, "style", $this->params->get( "style", "default" ));
			$position = $this->_params( $tipParams, "position", $this->params->get( "position", "cursor" ));
			$width    = $this->_params( $tipParams, "width", $this->params->get( "width", 300 ));
			$duration = $this->_params( $tipParams, "duration", $this->params->get( "duration", 300 ));
			$sticky   = $this->_params( $tipParams, "sticky", $this->params->get( "sticky", 0 ));
			$track   = $this->_params( $tipParams, "track", $this->params->get( "track", 0 )) ? ',target: "mouse",adjust:{x:10,y:10}': '';
			$event   = $this->_params( $tipParams, "event", $this->params->get( "event", 'mouseover' ));
			$rounded   = $this->_params( $tipParams, "rounded", $this->params->get( "rounded", 0 )) ? " ui-tooltip-rounded" : "";
			$shadows   = $this->_params( $tipParams, "shadows", $this->params->get( "shadows", 0 )) ? " ui-tooltip-shadow" : "";
			$modal      = $this->_params( $tipParams, "modal", 0 ) ? "modal: true,solo: true," : "";
			if($sticky == 1){$sticky1 =",button: true";$sticky2 ="hide:false,";}
			
			switch ($position) {
               case 'bottom_left':
                  $position = 'at: "bottom left",my: "top left",';
                  break;
               case 'bottom_right':
                  $position = 'at: "bottom right",my: "top right",';
                  break;
               case 'bottom_center':
                  $position = 'at: "bottom center",my: "top center",';
                  break;
			   case 'top_left':
                  $position = 'at: "top left",my: "bottom left",';
                  break;
			   case 'top_right':
                  $position = 'at: "top right",my: "bottom right",';
                  break;
			   case 'top_center':
                  $position = 'at: "top center",my: "bottom center",';
                  break;
			   case 'left_center':
                  $position = 'at: "left center",my: "right center",';
                  break;
			   case 'left_top':
                  $position = 'at: "left top",my: "right top",';
                  break;  
			   case 'left_bottom':
                  $position = 'at: "left bottom",my: "right bottom",';
                  break;
			   case 'right_center':
                  $position = 'at: "right center",my: "left center",';
                  break;
			   case 'right_top':
                  $position = 'at: "right top",my: "left top",';
                  break;
			   case 'right_bottom':
                  $position = 'at: "right bottom",my: "left bottom",';
                  break;
			   case 'center':
                  $position = 'at: "center",my: "center",';
                  break;
              }
			$element    = $this->_params( $tipParams, "element", $this->params->get( "element", "span"));
			$title      = str_replace('"','\'',$this->_params( $tipParams, "title", false ));
			$data      = str_replace('"','\'',$this->_params( $tipParams, "data", false ));
			$source      = $this->_params( $tipParams, "source", false );
			$link      = str_replace('"','\'',$this->_params( $tipParams, "link", false ));
			$modid      = str_replace('"','\'',$this->_params( $tipParams, "modid", false ));
			$coords      = str_replace('"','\'',$this->_params( $tipParams, "coords", false ));
			$articleid      = str_replace('"','\'',$this->_params( $tipParams, "articleid", false ));
			$externalurl      = $this->_params( $tipParams, "externalurl", false );
			$flickrid      = $this->_params( $tipParams, "flickrid", false );
			$flickrlimit      = $this->_params( $tipParams, "flickrlimit", 10 );
			$flicksmall      = $this->_params( $tipParams, "flickrthumb", '_m' );
			$piuserid      = $this->_params( $tipParams, "piuserid", false );
			$pialbumid      = $this->_params( $tipParams, "pialbumid", false );
			
			$imagePath = $this->cleanDir($this->_params( $tipParams, "imagepath", 'media/plg_vtemtooltip/images' ));
			$sortCriteria = $this->_params( $tipParams, "sortCriteria", 0 );
			$sortOrder = $this->_params( $tipParams, "sortOrder", 'asc' );
			$sortOrderManual = $this->_params( $tipParams, "sortOrderManual", '' );
			$thumbwidth = $this->_params( $tipParams, "thumbw", 150 );
			$thumbheight = $this->_params( $tipParams, "thumbh", 120 );
			if (trim($sortOrderManual) != "")
				$images = explode(",", $sortOrderManual);
			else
				$images = $this->imageList($imagePath, $sortCriteria, $sortOrder);
			
			if($source == "module"){
				if($modid){
				$data  = str_replace('"','\'',JModuleHelper::renderModule($this->getModule($modid)));
				}else{
				$data  = 'Please enter the following syntax: {vtemtooltip link=[Link text] title=[Module name] source=[module] modid=[16]}';
				}
			}
			
			if($source == "article"){
			$data  = "<iframe src='index.php?view=article&id=".$articleid."&tmpl=component' width='100%' height='100%'></iframe>";
			}
			
			if($source == "external"){
			$data  = "<iframe src='".$externalurl."' width='100%' height='100%'></iframe>";
			}
			
			if($source == "gallery"){
					$tooltip  .= '<div id="vtemtooltip'.(int)$i.'" class="warp_tooltip">';
						foreach($images as $img){
							  $tooltip .= '<a href="#" data="<img src=\''.JURI::root().$imagePath.$img.'\' />" title="'.$img.'" class="vtemtooltip">
									 <img src="'.JURI::root().$imagePath.$img.'" alt="" style="width:'.$thumbwidth.'px; height:'.$thumbheight.'px;"/>
									 </a>';
						 }
					$tooltip  .= '</div>';
			 }
			 if($source == "flickr"){
						$flickrId = $flickrid;
						$flickrrequest = 'http://api.flickr.com/services/feeds/photos_public.gne?id=' . $flickrId . '&format=json';
						$flickrci = curl_init($flickrrequest);
						curl_setopt($flickrci,CURLOPT_RETURNTRANSFER, TRUE);
						$flickrinput = curl_exec($flickrci);
						curl_close($flickrci);
						$flickrinput = str_replace('jsonFlickrFeed(','',$flickrinput);
						$flickrinput = str_replace('})','}',$flickrinput);
						$flickrvalue = json_decode($flickrinput,true);
						$flickritem = $flickrvalue['items'];
						$photosToDisplay = $flickrlimit;
						$tooltip  .= '<div id="vtemtooltip'. (int)$i .'" class="warp_tooltip">';
						for($p=0;$p<$photosToDisplay;$p++){
						$tooltip  .= "<a title='".$flickritem[$p]['title']."' class=\"vtemtooltip\" href=\"#\" data=\"<img src='" .str_replace('_m', '', $flickritem[$p]['media']['m']). "'/>\" ><img src=\"" .str_replace('_m', $flicksmall, $flickritem[$p]['media']['m']). "\" alt='".$flickritem[$p]['title']."'/></a>\n";
						}
						$tooltip  .= '</div>';
			 }
			if($source == "picasa"){
						$userid = $piuserid;
						$album = $pialbumid;
						$feedURL = "http://picasaweb.google.com/data/feed/base/user/$userid/albumid/$album";
						$sxml = simplexml_load_file($feedURL);
						$counts = $sxml->children('http://a9.com/-/spec/opensearchrss/1.0/'); 
						$tooltip  .= '<div id="vtemtooltip'. (int)$i .'" class="warp_tooltip">';
							foreach ($sxml->entry as $entry):
							  $gphoto = $entry->children('http://schemas.google.com/photos/2007');
							  $media = $entry->children('http://search.yahoo.com/mrss/');
							  $thumbnail = $media->group->thumbnail[1];
							  $bigimage = $media->group->content;
							  $tags = $media->group->keywords;
							  $tooltip  .="<a title='".$tags."' class=\"vtemtooltip\" href=\"#\" data=\"<img src='" .$bigimage->attributes()->{'url'}. "'/>\">
								  <img src=\"" . $thumbnail->attributes()->{'url'} . "\" alt='".$tags."'/>
							  </a>\n";
							endforeach;
						$tooltip  .= '</div>';
				}
		
			switch ($source) {
				case "youtube":
							$tooltip  .= '<a id="vtemtooltip'.(int)$i.'" class="vtemtooltip" title="'.$title.'" href="'.$data.'">'.$link.'</a>';
							$tooltip  .= '<script type="text/javascript" src="http://www.youtube.com/player_api"></script>';
							$tooltip  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery(\'#vtemtooltip'.(int)$i.'[href*="youtube.co"], #vtemtooltip'. (int)$i .'[href*="youtu.be"]\').each(function(){var videoID = this.href.match(/(youtu\.be\/|&*v=|\/v\/|\/embed\/)+([A-Za-z0-9\-_]{5,11})/);if(!videoID || videoID.length < 1) { return; }videoID = videoID[2] + jQuery.fn.qtip.nextid;jQuery(this).qtip({content: jQuery("<div />", { id: videoID }),position: {'.$position.' viewport: jQuery(window)'.$track.'},show:{event: "'.$event.'", '.$modal.' effect: function(){var style = this[0].style;style.display = "none";setTimeout(function(){style.display = "block"; }, 1);}},hide: "unfocus",style:{classes: "ui-tooltip-youtube",width: '.$width.'},events:{render: function(event, api){new YT.Player(videoID,{playerVars:{autoplay:1, enablejsapi:1, origin: document.location.host},origin: document.location.host,height: '.($width-150).',width: '.($width-18).',videoId: videoID.substr(0, 11),events:{"onReady": function(e){api.player = e.target;},}});},hide: function(event, api){if(api.player && api.player.stopVideo){ api.player.stopVideo();}}}}).click(false)});';
							$tooltip  .= '});</script>';
				break;
				case "vimeo":
							$tooltip  .= '<a id="vtemtooltip'.(int)$i.'" class="vtemtooltip" title="'.$title.'" href="'.$data.'">'.$link.'</a>';
							$tooltip  .= '<script type="text/javascript" src="http://a.vimeocdn.com/js/froogaloop2.min.js"></script>';
							$tooltip  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery(\'#vtemtooltip'.(int)$i.'[href*="vimeo.co"]\').each(function(){var videoID, html, id;id = "player_" + jQuery.fn.qtip.nextid;videoID = this.href.match(/http:\/\/(?:www\.)?vimeo.com\/(\d+)/);if (!videoID || videoID.length < 2) { return; }else{ videoID = videoID[1]; }html = \'<iframe src="http://player.vimeo.com/video/\' + videoID + \'?api=1&autoplay=1&player_id=\'+id+\'" \' + \'width="'.($width-18).'" height="'.($width-115).'" frameborder="0" id="\'+id+\'"></iframe>\';jQuery(this).qtip({content: html,position: {'.$position.' viewport: jQuery(window)'.$track.'},show:{event: "'.$event.'", '.$modal.' delay: '.$duration.'},hide: "unfocus",style:{classes: "ui-tooltip-vimeo ui-tooltip-youtube ui-tooltip-rounded ui-tooltip-shadow",width: '.$width.', height: '.($width-100).'},events:{render: function(event, api){var iframe = jQuery("iframe", this)[0];$f(iframe).addEvent("ready", function(player_id){api.player = $f(player_id);api.player.api("setVolume", 1);});},hide: function(event, api){ api.player.api("pause");}}}).click(false);});';
						   $tooltip  .= '});</script>';
				break;
				case "gmap":
						  $tooltip  .= '<'.$element.' id="vtemtooltip'.(int)$i.'" class="vtemtooltip" title="'.$title.'" data="'.$coords.'">'.$link.'</'. $element .'>';
						   $tooltip  .= '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>';
						   $tooltip  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery("#vtemtooltip'.(int)$i.'[data]").qtip({content:{
text: "Loading map...",title:{button: true}},position: {'.$position.' viewport:jQuery(window)'.$track.'},show:{event: "'.$event.'", '.$modal.' delay: '.$duration.'},hide: "unfocus",style:{classes: "ui-tooltip-googlemap ui-tooltip-shadow",width: '.$width.'},events:{render : function(event, api){var tooltip = jQuery(this),container = jQuery(\'<div style="width:'.($width-18).'px; height:'.($width-50).'px;"></div>\').appendTo(api.elements.content.empty());tooltip.show();api.map = new google.maps.Map(container[0],{zoom: 12,mapTypeId: google.maps.MapTypeId.ROADMAP});tooltip.hide();
},show: function(event, api){var map = api.map,target = api.elements.target,coords, latlong, map, marker, info;coords = target.attr("data").split(",");latlong = new google.maps.LatLng(parseFloat(coords[0]), parseFloat(coords[1]));marker = new google.maps.Marker({position: latlong,map: map,title: target.attr("title")}); map.setCenter(latlong);}}});';
						$tooltip  .= '});</script>';
				break;
				case "gallery":
				case "flickr":
				case "picasa":
				   $title = 1;
					$tooltip  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery("#vtemtooltip'.(int)$i.' .vtemtooltip").qtip({content:{text: function(api){return jQuery(this).attr("data");}';
					if($title){$tooltip  .= ',title:{text: function(api){return jQuery(this).attr("title");}'.$sticky1.'}';}
					$tooltip  .='},position:{'.$position.'viewport: jQuery(window)'.$track.'},show:{event: "'.$event.'", '.$modal.' delay: '.$duration.'}, '.$sticky2.' style:{classes: "ui-tooltip-'.$style.$rounded.$shadows.'", width: '.$width.'}';
					$tooltip  .= '});';
					$tooltip  .= '});</script>';
				break;
				case "module":
				case "article":
				case "external":
				default:
					$tooltip  .= '<'. $element .' id="vtemtooltip'. (int)$i .'" class="vtemtooltip" title="'.$title.'" data="'.$data.'">'.$link.'</'. $element .'>';
					$tooltip  .= '<script type="text/javascript">jQuery(document).ready(function(){jQuery("#vtemtooltip'. (int)$i .'").qtip({content:{text: function(api){return jQuery(this).attr("data");}';
					if($title){$tooltip  .= ',title:{text: function(api){return jQuery(this).attr("title");}'.$sticky1.'}';}
					$tooltip  .='},position:{'.$position.'viewport: jQuery(window)'.$track.'},show:{event: "'.$event.'", '.$modal.' delay: '.$duration.'}, '.$sticky2.' style:{classes: "ui-tooltip-'.$style.$rounded.$shadows.'", width: '.$width.'}';
					$tooltip  .= '});';
					$tooltip  .= '});</script>';
			}

			$body = str_replace($matches[0][$i], $tooltip, $body);
		}
		JResponse::setBody($body);
	}

	private function _params( $TipParams, $param, $default = false ){
		$regex = "/". $param ."=(\s*\[.*?\])/s";
		preg_match_all( $regex, $TipParams, $options );
		$value = !empty($options[1][0]) ? JString::trim( $options[1][0], '[]' ) : trim($default);
		return $value;
	}
	
	private function getModule($id){
		$db		=& JFactory::getDBO();
		$where = ' AND ( m.id='.$id.' ) ';
		$query = 'SELECT *'.
			' FROM #__modules AS m'.
			' WHERE m.client_id = 0'.
			$where.
			' ORDER BY ordering'.
			' LIMIT 1';
		$db->setQuery( $query );
		$module = $db->loadObject();
		if (!$module) return null;
		$file				= $module->module;
		$custom				= substr($file, 0, 4) == 'mod_' ?  0 : 1;
		$module->user		= $custom;
		$module->name		= $custom ? $module->title : substr($file, 4);
		$module->style		= null;
		$module->position	= strtolower($module->position);
		$clean[$module->id]	= $module;
		return $module;
	}
	
	private function imageList ($directory, $sortcriteria, $sortorder) {
	    $results = array();
	    $handler = opendir($directory);
			$i = 0;
	    while ($file = readdir($handler)) {
	        if ($file != '.' && $file != '..' && $this->isImage($file)) {
						$results[$i][0] = $file;
						$results[$i][1] = filemtime($directory . "/" .$file);
						$i++;
					}
	    }
	    closedir($handler);

			foreach($results as $res) {
				if ($sortcriteria == 0 ) $sortAux[] = $res[0];
				else $sortAux[] = $res[1];
			}

			if ($sortorder == 0) {
				array_multisort($sortAux, SORT_ASC, $results);
			} elseif ($sortorder == 2) {
				srand((float)microtime() * 1000000);
				shuffle($results);
			} else {
				array_multisort($sortAux, SORT_DESC, $results);
			}

			foreach($results as $res) {
				$sorted_results[] = $res[0];
			}

	    return $sorted_results;
	}

	private function isImage($file) {
		$imagetypes = array(".jpg", ".jpeg", ".gif", ".png");
		$extension = substr($file,strrpos($file,"."));
		if (in_array($extension, $imagetypes)) return true;
		else return false;
	}
	
	private function cleanDir($dir) {
		if (substr($dir, -1, 1) == '/')
			return $dir;
		else
			return $dir . "/";
	}
	
}
?>